
; CC5X Version 3.1I, Copyright (c) B Knudsen Data
; C compiler for the PICmicro family
; ************  20. Jun 2006  18:13  *************

	processor  16F88
	radix  DEC

INDF        EQU   0x00
PCL         EQU   0x02
FSR         EQU   0x04
PORTA       EQU   0x05
TRISA       EQU   0x85
PORTB       EQU   0x06
TRISB       EQU   0x86
PCLATH      EQU   0x0A
Carry       EQU   0
Zero_       EQU   2
RP0         EQU   5
RP1         EQU   6
IRP         EQU   7
RCSTA       EQU   0x18
TXREG       EQU   0x19
RCREG       EQU   0x1A
TXSTA       EQU   0x98
SPBRG       EQU   0x99
ANSEL       EQU   0x9B
TXIF        EQU   4
RCIF        EQU   5
in_byte     EQU   0x21
choice      EQU   0x22
x_val       EQU   0x23
y_val       EQU   0x25
z_val       EQU   0x27
register_name EQU   0x29
in_byte_2   EQU   0x2A
register_name_2 EQU   0x23
register_value EQU   0x24
in_byte_3   EQU   0x25
outgoing_byte EQU   0x2B
incoming_byte EQU   0x2C
x           EQU   0x2D
x_2         EQU   0x29
y           EQU   0x2B
z           EQU   0x2C
nate        EQU   0x39
counter     EQU   0x7F
x_3         EQU   0x39
nate_2      EQU   0x29
my_byte     EQU   0x2A
i           EQU   0x2C
k           EQU   0x2D
m           EQU   0x2E
temp        EQU   0x2F
high_byte   EQU   0x30
low_byte    EQU   0x31
C1cnt       EQU   0x39
C2tmp       EQU   0x3A
C3cnt       EQU   0x39
C4tmp       EQU   0x3A
C5cnt       EQU   0x39
C6tmp       EQU   0x3A
C7rem       EQU   0x3C
ci          EQU   0x39

	GOTO main

  ; FILE C:\Global\Code\16F88\LIS-Testing\LIS3LV02DQ-Tester.c
			;/*
			;    6-20-06
			;    Nathan Seidle
			;    nathan@sparkfun.com
			;    Copyright Spark Fun Electronics 2006
			;    
			;    Software SPI control
			;    PIC 16F88
			;    
			;    Reading and writing to LIS3LV02DQ
			;    
			;    This is a very powerful, configurable, and precise triple axis accelerometer.
			;    
			;    At first look, the interface can be daunting, but once things are running,
			;    this is an impressive little sensor!
			;    
			;*/
			;#define Clock_8MHz
			;#define Baud_9600
			;
			;#include "c:\Global\Code\C\16F88.h"  // device dependent interrupt definitions
			;
			;#pragma origin 4
	ORG 0x0004
			;
			;#define STATUS_LED PORTB.3
			;
			;#define INT PORTA.0 //This is interrupt, not used, read as input and leave floating
			;#define SDO PORTA.1 //This is output from the LIS into the PIC
			;#define SDI PORTA.2 //This is input into the LIS from the PIC
			;#define SCL PORTB.0 //This is a clock into the LIS from the PIC
			;#define CS  PORTB.1 //This is input into LIS from PIC - Low for SPI mode
			;#define CK  PORTB.4 //Not used - pull low to ground
			;
			;void boot_up(void);
			;
			;uns8 spi_comm(uns8 outgoing_byte);
			;uns8 read_register(uns8 register_name);
			;void write_register(uns8 register_name, uns8 register_value);
			;void LIS3LV02DQ_Test(void);
			;
			;void delay_ms(uns16 x);
			;uns8 bin2Hex(char x);
			;void printf(const char *nate, int16 my_byte);
			;
			;void main(void)
			;{
_const1
	MOVWF ci
	CLRF  PCLATH
	MOVF  ci,W
	ANDLW .31
	ADDWF PCL,1
	RETLW .87
	RETLW .65
	RETLW .73
	RETLW .61
	RETLW .37
	RETLW .104
	RETLW .32
	RETLW .0
	RETLW .120
	RETLW .61
	RETLW .37
	RETLW .100
	RETLW .32
	RETLW .0
	RETLW .121
	RETLW .61
	RETLW .37
	RETLW .100
	RETLW .32
	RETLW .0
	RETLW .122
	RETLW .61
	RETLW .37
	RETLW .100
	RETLW .32
	RETLW .0
	RETLW .10
	RETLW .13
	RETLW .0
	RETLW .0
	RETLW .0
	RETLW .0
main
			;    uns8 out_byte, in_byte, choice;
			;    
			;    boot_up(); //Init ports and settings
	BSF   0x03,RP0
	BCF   0x03,RP1
	CALL  boot_up
			;        
			;    
			;    CS = 1; //Unselect LIS
	BSF   PORTB,1
			;    CK = 0;
	BCF   PORTB,4
			;        
			;    STATUS_LED = 0;
	BCF   PORTB,3
			;
			;    in_byte = read_register(0x0F); //Read register WHO_AM_I
	MOVLW .15
	CALL  read_register
	MOVWF in_byte
			;    printf("WAI=%h ", in_byte);
	CLRF  nate_2
	MOVWF my_byte
	CLRF  my_byte+1
	CALL  printf
			;
			;    in_byte = read_register(0x0F); //Read register WHO_AM_I
	MOVLW .15
	CALL  read_register
	MOVWF in_byte
			;    printf("WAI=%h ", in_byte);
	CLRF  nate_2
	MOVWF my_byte
	CLRF  my_byte+1
	CALL  printf
			;
			;    write_register(0x20, 0b.1000.0111); //Power on device, enable all axis, and turn off self test - CTRL_REG1
	MOVLW .32
	MOVWF register_name_2
	MOVLW .135
	CALL  write_register
			;
			;    while(1)
			;    {
			;        STATUS_LED ^= 1;
m001	MOVLW .8
	XORWF PORTB,1
			;
			;        if(RCIF)
	BTFSS 0x0C,RCIF
	GOTO  m002
			;        {
			;            choice = RCREG;
	MOVF  RCREG,W
	MOVWF choice
			;            
			;            if(choice == 'x') break;
	XORLW .120
	BTFSC 0x03,Zero_
	GOTO  m003
			;        }
			;        
			;        int16 x_val, y_val, z_val;
			;        x_val.low8 = read_register(0x28); //Read outx_l
m002	MOVLW .40
	CALL  read_register
	MOVWF x_val
			;        x_val.high8 = read_register(0x29); //Read outx_h
	MOVLW .41
	CALL  read_register
	MOVWF x_val+1
			;        printf("x=%d ", x_val);
	MOVLW .8
	MOVWF nate_2
	MOVF  x_val,W
	MOVWF my_byte
	MOVF  x_val+1,W
	MOVWF my_byte+1
	CALL  printf
			;
			;        y_val.low8 = read_register(0x2A); //Read outy_l
	MOVLW .42
	CALL  read_register
	MOVWF y_val
			;        y_val.high8 = read_register(0x2B); //Read outy_h
	MOVLW .43
	CALL  read_register
	MOVWF y_val+1
			;        printf("y=%d ", y_val);
	MOVLW .14
	MOVWF nate_2
	MOVF  y_val,W
	MOVWF my_byte
	MOVF  y_val+1,W
	MOVWF my_byte+1
	CALL  printf
			;
			;        z_val.low8 = read_register(0x2C); //Read outz_l
	MOVLW .44
	CALL  read_register
	MOVWF z_val
			;        z_val.high8 = read_register(0x2D); //Read outz_h
	MOVLW .45
	CALL  read_register
	MOVWF z_val+1
			;        printf("z=%d ", z_val);
	MOVLW .20
	MOVWF nate_2
	MOVF  z_val,W
	MOVWF my_byte
	MOVF  z_val+1,W
	MOVWF my_byte+1
	CALL  printf
			;
			;        printf("\n\r", 0);
	MOVLW .26
	MOVWF nate_2
	CLRF  my_byte
	CLRF  my_byte+1
	CALL  printf
			;        
			;        delay_ms(50);
	MOVLW .50
	MOVWF x_2
	CLRF  x_2+1
	CALL  delay_ms
			;    }
	GOTO  m001
			;
			;    while(1);
m003	GOTO  m003
			;
			;
			;}//End Main
			;
			;
			;void boot_up(void)
			;{
boot_up
			;    //OSCCON = 0b.0111.0000; //Setup internal oscillator for 8MHz
			;    //while(OSCCON.2 == 0); //Wait for frequency to stabilize
			;
			;    //Setup Ports
			;    ANSEL = 0b.0000.0000; //Turn off A/D
	CLRF  ANSEL
			;
			;    //Read RA0, RA1
			;    PORTA = 0b.0000.0000;
	BCF   0x03,RP0
	CLRF  PORTA
			;    TRISA = 0b.0000.0011;  //0 = Output, 1 = Input
	MOVLW .3
	BSF   0x03,RP0
	MOVWF TRISA
			;
			;    //Output RB0, RB1, RB4
			;    PORTB = 0b.0000.0000;
	BCF   0x03,RP0
	CLRF  PORTB
			;    TRISB = 0b.0000.0100;   //0 = Output, 1 = Input RX on RB2
	MOVLW .4
	BSF   0x03,RP0
	MOVWF TRISB
			;
			;    //Setup the hardware UART module
			;    //=============================================================
			;    SPBRG = 51; //8MHz for 9600 inital communication baud rate
	MOVLW .51
	MOVWF SPBRG
			;    //SPBRG = 129; //20MHz for 9600 inital communication baud rate
			;
			;    TXSTA = 0b.0010.0100; //8-bit asych mode, high speed uart enabled
	MOVLW .36
	MOVWF TXSTA
			;    RCSTA = 0b.1001.0000; //Serial port enable, 8-bit asych continous receive mode
	MOVLW .144
	BCF   0x03,RP0
	MOVWF RCSTA
			;    //=============================================================
			;}
	RETURN
			;
			;//Sends read command to LIS
			;uns8 read_register(uns8 register_name)
			;{
read_register
	MOVWF register_name
			;    uns8 in_byte;
			;    
			;    register_name |= 0b.1000.0000; //Set D7 to 1 for read mode
	BSF   register_name,7
			;
			;    CS = 0; //Select LIS
	BCF   PORTB,1
			;
			;    in_byte = spi_comm(register_name); //SPI read 6-bit register from LIS
	MOVF  register_name,W
	CALL  spi_comm
	MOVWF in_byte_2
			;    //printf("In1 = %h ", in_byte);
			;    
			;    //in_byte is nothing, we need to clock in another 8 bits
			;    in_byte = spi_comm(0x00); //Send nothing, but we should get back the register value
	MOVLW .0
	CALL  spi_comm
	MOVWF in_byte_2
			;    
			;    CS = 1;
	BSF   PORTB,1
			;    
			;    return(in_byte);
	RETURN
			;}
			;
			;//Sends a write command to LIS
			;void write_register(uns8 register_name, uns8 register_value)
			;{
write_register
	MOVWF register_value
			;    uns8 in_byte;
			;    
			;    register_name &= 0b.0111.1111; //Clear D7 to 0 for write mode
	BCF   register_name_2,7
			;
			;    CS = 0; //Select LIS
	BCF   PORTB,1
			;
			;    in_byte = spi_comm(register_name); //SPI read 6-bit register from LIS
	MOVF  register_name_2,W
	CALL  spi_comm
	MOVWF in_byte_3
			;    //printf("In1 = %h ", in_byte);
			;    
			;    //in_byte is nothing, we need to clock in the value to write
			;    in_byte = spi_comm(register_value); //Send nothing, but we should get back the register value
	MOVF  register_value,W
	CALL  spi_comm
	MOVWF in_byte_3
			;    
			;    CS = 1;
	BSF   PORTB,1
			;    
			;    //Return nothing
			;}
	RETURN
			;
			;//Basic SPI send and receive
			;uns8 spi_comm(uns8 outgoing_byte)
			;{
spi_comm
	MOVWF outgoing_byte
			;    uns8 incoming_byte, x;
			;
			;    SCL = 1; //Pull SPI clock high
	BSF   PORTB,0
			;    for(x = 0 ; x < 8 ; x++)
	CLRF  x
m004	MOVLW .8
	SUBWF x,W
	BTFSC 0x03,Carry
	GOTO  m005
			;    {
			;        SDI = outgoing_byte.7; //Put bit on SPI data bus
	BTFSS outgoing_byte,7
	BCF   PORTA,2
	BTFSC outgoing_byte,7
	BSF   PORTA,2
			;        outgoing_byte <<= 1; //Rotate byte 1 to the left
	BCF   0x03,Carry
	RLF   outgoing_byte,1
			;
			;        SCL = 0; //Toggle the SPI clock
	BCF   PORTB,0
			;        SCL = 1;
	BSF   PORTB,0
			;
			;        incoming_byte <<= 1; //Rotate byte 1 to the left
	BCF   0x03,Carry
	RLF   incoming_byte,1
			;        incoming_byte.0 = SDO; //Read bit on SPI data bus
	BCF   incoming_byte,0
	BTFSC PORTA,1
	BSF   incoming_byte,0
			;    }
	INCF  x,1
	GOTO  m004
			;    
			;    return(incoming_byte);
m005	MOVF  incoming_byte,W
	RETURN
			;}
			;
			;//General short delay
			;void delay_ms(uns16 x)
			;{
delay_ms
			;
			;    //Clocks out at 1006us per 1ms
			;    uns8 y, z;
			;    for ( ; x > 0 ; x--)
m006	MOVF  x_2,W
	IORWF x_2+1,W
	BTFSC 0x03,Zero_
	GOTO  m011
			;        for ( y = 0 ; y < 4 ; y++)
	CLRF  y
m007	MOVLW .4
	SUBWF y,W
	BTFSC 0x03,Carry
	GOTO  m010
			;            for ( z = 0 ; z < 69 ; z++);
	CLRF  z
m008	MOVLW .69
	SUBWF z,W
	BTFSC 0x03,Carry
	GOTO  m009
	INCF  z,1
	GOTO  m008
m009	INCF  y,1
	GOTO  m007
m010	DECF  x_2,1
	INCF  x_2,W
	BTFSC 0x03,Zero_
	DECF  x_2+1,1
	GOTO  m006
			;}
m011	RETURN
			;
			;//Sends nate to the Transmit Register
			;void putc(uns8 nate)
			;{
putc
	MOVWF nate
			;    while(TXIF == 0);
m012	BTFSS 0x0C,TXIF
	GOTO  m012
			;    TXREG = nate;
	MOVF  nate,W
	MOVWF TXREG
			;}
	RETURN
			;
			;uns8 getc(void)
			;{
getc
			;    while(RCIF == 0);
	BCF   0x03,RP0
	BCF   0x03,RP1
m013	BTFSS 0x0C,RCIF
	GOTO  m013
			;    return (RCREG);
	MOVF  RCREG,W
	RETURN
			;}    
			;
			;uns8 scanc(void)
			;{
scanc
			;    uns16 counter = 0;
	CLRF  counter
	CLRF  counter+1
			;    
			;    //CREN = 0;
			;    //CREN = 1;
			;    
			;    RCIF = 0;
	BCF   0x03,RP0
	BCF   0x03,RP1
	BCF   0x0C,RCIF
			;    while(RCIF == 0)
m014	BTFSC 0x0C,RCIF
	GOTO  m015
			;    {
			;        counter++;
	INCF  counter,1
	BTFSC 0x03,Zero_
	INCF  counter+1,1
			;        if(counter == 1000) return 0;
	MOVF  counter,W
	XORLW .232
	BTFSS 0x03,Zero_
	GOTO  m014
	MOVF  counter+1,W
	XORLW .3
	BTFSS 0x03,Zero_
	GOTO  m014
	RETLW .0
			;    }
			;    
			;    return (RCREG);
m015	MOVF  RCREG,W
	RETURN
			;}   
			;
			;//Returns ASCII Decimal and Hex values
			;uns8 bin2Hex(char x)
			;{
bin2Hex
	MOVWF x_3
			;   skip(x);
	CLRF  PCLATH
	MOVF  x_3,W
	ADDLW .253
	BTFSC 0x03,Carry
	INCF  PCLATH,1
	MOVWF PCL
			;   #pragma return[16] = "0123456789ABCDEF"
	RETLW .48
	RETLW .49
	RETLW .50
	RETLW .51
	RETLW .52
	RETLW .53
	RETLW .54
	RETLW .55
	RETLW .56
	RETLW .57
	RETLW .65
	RETLW .66
	RETLW .67
	RETLW .68
	RETLW .69
	RETLW .70
			;}
			;
			;//Prints a string including variables
			;void printf(const char *nate, int16 my_byte)
			;{
printf
			;  
			;    uns8 i, k, m, temp;
			;    uns8 high_byte = 0, low_byte = 0;
	CLRF  high_byte
	CLRF  low_byte
			;    uns8 y, z;
			;    
			;    uns8 decimal_output[5];
			;    
			;    for(i = 0 ; ; i++)
	CLRF  i
			;    {
			;        //delay_ms(3);
			;        
			;        k = nate[i];
m016	MOVF  i,W
	ADDWF nate_2,W
	CALL  _const1
	MOVWF k
			;
			;        if (k == '\0') 
	MOVF  k,1
	BTFSC 0x03,Zero_
			;            break;
	GOTO  m042
			;
			;        else if (k == '%') //Print var
	XORLW .37
	BTFSS 0x03,Zero_
	GOTO  m040
			;        {
			;            i++;
	INCF  i,1
			;            k = nate[i];
	MOVF  i,W
	ADDWF nate_2,W
	CALL  _const1
	MOVWF k
			;
			;            if (k == '\0') 
	MOVF  k,1
	BTFSC 0x03,Zero_
			;                break;
	GOTO  m042
			;            else if (k == '\\') //Print special characters
	XORLW .92
	BTFSS 0x03,Zero_
	GOTO  m017
			;            {
			;                i++;
	INCF  i,1
			;                k = nate[i];
	MOVF  i,W
	ADDWF nate_2,W
	CALL  _const1
	MOVWF k
			;                
			;                putc(k);
	CALL  putc
			;                
			;
			;            } //End Special Characters
			;            else if (k == 'b') //Print Binary
	GOTO  m041
m017	MOVF  k,W
	XORLW .98
	BTFSS 0x03,Zero_
	GOTO  m022
			;            {
			;                for( m = 0 ; m < 8 ; m++ )
	CLRF  m
m018	MOVLW .8
	SUBWF m,W
	BTFSC 0x03,Carry
	GOTO  m041
			;                {
			;                    if (my_byte.7 == 1) putc('1');
	BTFSS my_byte,7
	GOTO  m019
	MOVLW .49
	CALL  putc
			;                    if (my_byte.7 == 0) putc('0');
m019	BTFSC my_byte,7
	GOTO  m020
	MOVLW .48
	CALL  putc
			;                    if (m == 3) putc(' ');
m020	MOVF  m,W
	XORLW .3
	BTFSS 0x03,Zero_
	GOTO  m021
	MOVLW .32
	CALL  putc
			;                    
			;                    my_byte = my_byte << 1;
m021	BCF   0x03,Carry
	RLF   my_byte,1
	RLF   my_byte+1,1
			;                }
	INCF  m,1
	GOTO  m018
			;            } //End Binary               
			;            else if (k == 'd') //Print Decimal
m022	MOVF  k,W
	XORLW .100
	BTFSS 0x03,Zero_
	GOTO  m036
			;            {
			;                //Print negative sign and take 2's compliment
			;                
			;                if(my_byte < 0)
	BTFSS my_byte+1,7
	GOTO  m025
			;                {
			;                    putc('-');
	MOVLW .45
	CALL  putc
			;                    my_byte *= -1;
	MOVF  my_byte,W
	MOVWF C2tmp
	MOVF  my_byte+1,W
	MOVWF C2tmp+1
	MOVLW .16
	MOVWF C1cnt
m023	BCF   0x03,Carry
	RLF   my_byte,1
	RLF   my_byte+1,1
	RLF   C2tmp,1
	RLF   C2tmp+1,1
	BTFSS 0x03,Carry
	GOTO  m024
	DECF  my_byte+1,1
	DECF  my_byte,1
	INCFSZ my_byte,W
	INCF  my_byte+1,1
m024	DECFSZ C1cnt,1
	GOTO  m023
			;                }
			;                
			;                
			;                if (my_byte == 0)
m025	MOVF  my_byte,W
	IORWF my_byte+1,W
	BTFSS 0x03,Zero_
	GOTO  m026
			;                    putc('0');
	MOVLW .48
	CALL  putc
			;                else
	GOTO  m041
			;                {
			;                    //Divide number by a series of 10s
			;                    for(m = 4 ; my_byte > 0 ; m--)
m026	MOVLW .4
	MOVWF m
m027	BTFSC my_byte+1,7
	GOTO  m034
	MOVF  my_byte,W
	IORWF my_byte+1,W
	BTFSC 0x03,Zero_
	GOTO  m034
			;                    {
			;                        temp = my_byte % (uns16)10;
	MOVF  my_byte,W
	MOVWF C4tmp
	MOVF  my_byte+1,W
	MOVWF C4tmp+1
	CLRF  temp
	MOVLW .16
	MOVWF C3cnt
m028	RLF   C4tmp,1
	RLF   C4tmp+1,1
	RLF   temp,1
	BTFSC 0x03,Carry
	GOTO  m029
	MOVLW .10
	SUBWF temp,W
	BTFSS 0x03,Carry
	GOTO  m030
m029	MOVLW .10
	SUBWF temp,1
m030	DECFSZ C3cnt,1
	GOTO  m028
			;                        decimal_output[m] = temp;
	MOVLW .52
	ADDWF m,W
	MOVWF FSR
	BCF   0x03,IRP
	MOVF  temp,W
	MOVWF INDF
			;                        my_byte = my_byte / (uns16)10;               
	MOVF  my_byte,W
	MOVWF C6tmp
	MOVF  my_byte+1,W
	MOVWF C6tmp+1
	CLRF  C7rem
	MOVLW .16
	MOVWF C5cnt
m031	RLF   C6tmp,1
	RLF   C6tmp+1,1
	RLF   C7rem,1
	BTFSC 0x03,Carry
	GOTO  m032
	MOVLW .10
	SUBWF C7rem,W
	BTFSS 0x03,Carry
	GOTO  m033
m032	MOVLW .10
	SUBWF C7rem,1
	BSF   0x03,Carry
m033	RLF   my_byte,1
	RLF   my_byte+1,1
	DECFSZ C5cnt,1
	GOTO  m031
			;                    }
	DECF  m,1
	GOTO  m027
			;                
			;                    for(m++ ; m < 5 ; m++)
m034	INCF  m,1
m035	MOVLW .5
	SUBWF m,W
	BTFSC 0x03,Carry
	GOTO  m041
			;                        putc(bin2Hex(decimal_output[m]));
	MOVLW .52
	ADDWF m,W
	MOVWF FSR
	BCF   0x03,IRP
	MOVF  INDF,W
	CALL  bin2Hex
	CALL  putc
	INCF  m,1
	GOTO  m035
			;                }
			;    
			;            } //End Decimal
			;            else if (k == 'h') //Print Hex
m036	MOVF  k,W
	XORLW .104
	BTFSS 0x03,Zero_
	GOTO  m038
			;            {
			;                //New trick 3-15-04
			;                putc('0');
	MOVLW .48
	CALL  putc
			;                putc('x');
	MOVLW .120
	CALL  putc
			;                
			;                if(my_byte > 0x00FF)
	BTFSC my_byte+1,7
	GOTO  m037
	MOVF  my_byte+1,1
	BTFSC 0x03,Zero_
	GOTO  m037
			;                {
			;                    putc(bin2Hex(my_byte.high8 >> 4));
	SWAPF my_byte+1,W
	ANDLW .15
	CALL  bin2Hex
	CALL  putc
			;                    putc(bin2Hex(my_byte.high8 & 0b.0000.1111));
	MOVLW .15
	ANDWF my_byte+1,W
	CALL  bin2Hex
	CALL  putc
			;                }
			;
			;                putc(bin2Hex(my_byte.low8 >> 4));
m037	SWAPF my_byte,W
	ANDLW .15
	CALL  bin2Hex
	CALL  putc
			;                putc(bin2Hex(my_byte.low8 & 0b.0000.1111));
	MOVLW .15
	ANDWF my_byte,W
	CALL  bin2Hex
	CALL  putc
			;
			;                /*high_byte.3 = my_byte.7;
			;                high_byte.2 = my_byte.6;
			;                high_byte.1 = my_byte.5;
			;                high_byte.0 = my_byte.4;
			;            
			;                low_byte.3 = my_byte.3;
			;                low_byte.2 = my_byte.2;
			;                low_byte.1 = my_byte.1;
			;                low_byte.0 = my_byte.0;
			;        
			;                putc('0');
			;                putc('x');
			;            
			;                putc(bin2Hex(high_byte));
			;                putc(bin2Hex(low_byte));*/
			;            } //End Hex
			;            else if (k == 'f') //Print Float
	GOTO  m041
m038	MOVF  k,W
	XORLW .102
	BTFSS 0x03,Zero_
	GOTO  m039
			;            {
			;                putc('!');
	MOVLW .33
	CALL  putc
			;            } //End Float
			;            else if (k == 'u') //Print Direct Character
	GOTO  m041
m039	MOVF  k,W
	XORLW .117
	BTFSS 0x03,Zero_
	GOTO  m041
			;            {
			;                //All ascii characters below 20 are special and screwy characters
			;                //if(my_byte > 20) 
			;                    putc(my_byte);
	MOVF  my_byte,W
	CALL  putc
			;            } //End Direct
			;                        
			;        } //End Special Chars           
			;
			;        else
	GOTO  m041
			;            putc(k);
m040	MOVF  k,W
	CALL  putc
			;    }    
m041	INCF  i,1
	GOTO  m016
m042	RETURN

	END


; *** KEY INFO ***

; 0x007C P0   19 word(s)  0 % : boot_up
; 0x00A5 P0   24 word(s)  1 % : spi_comm
; 0x008F P0   11 word(s)  0 % : read_register
; 0x009A P0   11 word(s)  0 % : write_register
; 0x00BD P0   24 word(s)  1 % : delay_ms
; 0x00F6 P0   23 word(s)  1 % : bin2Hex
; 0x010D P0  215 word(s) 10 % : printf
; 0x0029 P0   83 word(s)  4 % : main
; 0x00D5 P0    6 word(s)  0 % : putc
; 0x00DB P0    6 word(s)  0 % : getc
; 0x00E1 P0   21 word(s)  1 % : scanc
; 0x0004 P0   37 word(s)  1 % : _const1

; RAM usage: 30 bytes (30 local), 338 bytes free
; Maximum call level: 2
;  Codepage 0 has  481 word(s) :  23 %
;  Codepage 1 has    0 word(s) :   0 %
; Total of 481 code words (11 %)
